<template>
  <div class="profile">
    <a-form @submit.prevent="saveForm()" class="form">
      <a-input-group compact>
        <a-input
          style="width: 100%"
          v-model:value="userName"
          placeholder="Name"
        >
          <template #prefix>
            <user-outlined />
          </template>
        </a-input>
        <br />
        <br />
        <a-select
          style="width: 100%"
          ref="select"
          :value="theme"
          @change="handleChangeTheme"
        >
          <a-select-option value="light">light</a-select-option>
          <a-select-option value="dark">dark</a-select-option>
        </a-select>
        <br />
        <br />

        <a-select
          style="width: 100%"
          ref="select"
          :value="language"
          @change="handleChangeLanguage"
        >
          <a-select-option value="en">English</a-select-option>
          <a-select-option value="fa">Persian(فارسی)</a-select-option>
        </a-select>

        <br />
        <br />
        <a-button html-type="submit" type="primary">{{
          $t("profile.saveButton")
        }}</a-button>
      </a-input-group>
    </a-form>
  </div>
</template>
<script lang="ts">
import { UserOutlined } from "@ant-design/icons-vue";
import { ref } from "vue";
import store from "@/store";
import { i18n } from "../main";
const userName = ref<string>("");

export default {
  setup() {
    const newName = ref("");
    const userNameData =
      JSON.parse(localStorage.getItem("userName") ?? "[]") || "";
    const userName = ref(userNameData);

    const themeData = JSON.parse(localStorage.getItem("theme") ?? "[]") || "";
    const theme = ref(themeData);

    const languageData =
      JSON.parse(localStorage.getItem("language") ?? "[]") || "";
    const language = ref(languageData);

    function saveForm() {
      saveData();
      saveStore();
    }

    function saveData() {
      const storageName = JSON.stringify(userName.value);
      localStorage.setItem("userName", storageName);

      const storageTheme = JSON.stringify(theme.value);
      localStorage.setItem("theme", storageTheme);

      const storageLanguage = JSON.stringify(language.value);
      localStorage.setItem("language", storageLanguage);
    }

    function saveStore() {
      store.commit("setTheme", theme);
      store.commit("setUserName", userName);
      store.commit("setLanguage", language);
      i18n.global.locale = store.state.language;
    }

    const handleChangeTheme = (value: string) => {
      theme.value = value;
    };

    const handleChangeLanguage = (value: string) => {
      language.value = value;
    };

    return {
      userName,
      newName,
      saveData,
      saveForm,
      handleChangeTheme,
      handleChangeLanguage,
      language,
      theme,
    };
  },
};
</script>

<style lang="scss">
.profile {
  width: 30%;
  @media only screen and (max-width: 1000px) {
    width: 50%;
  }
  @media only screen and (max-width: 700px) {
    width: 80%;
  }
  @media only screen and (max-width: 500px) {
    width: 80%;
  }
  .form {
    width: 100%;
  }
}
</style>
